advancement revoke @s only clgd.lodestone:teleport

# Delete the thrown enderpearl
kill @e[type=ender_pearl,distance=..3,limit=1]

# Get Lodestone Data
execute if predicate clgd.lodestone:compass_mainhand run function clgd.lodestone:_private/get_pos_mainhand
execute if predicate clgd.lodestone:compass_offhand run function clgd.lodestone:_private/get_pos_offhand

# Fail if player is not in the same dimension as destination
execute store success score $WrongDimension clgd.lodestone run data modify storage clgd:lodestone Dimension set from entity @s Dimension
execute if score $WrongDimension clgd.lodestone matches 1 run scoreboard players set $Fail clgd.lodestone 1

# Calculate distance & check if lodestone is too far away
function clgd.lodestone:_private/calculate_distance
execute if score $Dist clgd.lodestone >= $MaxDistance clgd.lodestone run scoreboard players set $Fail clgd.lodestone 1
execute if score $Dist clgd.lodestone matches ..-1 run scoreboard players set $Fail clgd.lodestone 1

# Calculate XP Cost
function clgd.lodestone:_private/get_player_xp
scoreboard players operation $XPRequired clgd.lodestone = $XPCost clgd.lodestone
execute unless predicate clgd.lodestone:menu/fixed_xp_cost run scoreboard players operation $XPRequired clgd.lodestone *= $Dist clgd.lodestone
execute unless predicate clgd.lodestone:menu/fixed_xp_cost run scoreboard players operation $XPRequired clgd.lodestone /= #100 clgd.lodestone
execute if score $XPRequired clgd.lodestone > $PlayerXP clgd.lodestone run scoreboard players set $Fail clgd.lodestone 1
execute if score $XPRequired clgd.lodestone matches ..-1 run scoreboard players set $Fail clgd.lodestone 1

# Cooldown check
execute if score @s clgd.lodestone.warp_cooldown matches 1.. run scoreboard players set $Fail clgd.lodestone 1

# Fail if lodestone is required and player is not standing on it
execute if predicate clgd.lodestone:menu/lodestone_required unless block ~ ~-1 ~ minecraft:lodestone run scoreboard players set $Fail clgd.lodestone 1

# Give proper error message (ordered by priority, higher prioity comes later)

# Player does not have enough experience
execute if score $XPRequired clgd.lodestone matches ..-1 run data modify storage smithed.actionbar:input message set value {priority:'notification',freeze: 50,json:'[{"text":"Too Expensive!","color":"red"}]'}

execute if score $XPrequired clgd.lodestone > $PlayerXP clgd.lodestone run data modify storage smithed.actionbar:input message set value {priority:'notification',freeze: 50,json:'[{"text":"Not enough experience. You have: ","color":"red"},{"score":{"name":"$PlayerXP","objective":"clgd.lodestone"}},{"text":", Reqired: "},{"score":{"name":"$XPRequired","objective":"clgd.lodestone"}}]'}

# Too Far Away
execute if score $Dist clgd.lodestone matches ..-1 run data modify storage smithed.actionbar:input message set value {priority:'notification',freeze: 50,json:'[{"text":"Lodestone is too far away!","color":"red"}]'}
execute if score $Dist clgd.lodestone > $MaxDistance clgd.lodestone run data modify storage smithed.actionbar:input message set value {priority:'notification',freeze: 50,json:'[{"text":"Lodestone is too far away!","color":"red"}]'}


# Warping still on cooldown
execute if score @s clgd.lodestone.warp_cooldown matches 1.. run data modify storage smithed.actionbar:input message set value {priority:'notification',freeze: 50,json:'[{"text":"Warp on cooldown! ","color":"red"},{"score":{"name":"@s","objective":"clgd.lodestone.warp_cooldown"}},{"text":"s remaining."}]'}

# Not standing on a lodestone
execute if predicate clgd.lodestone:menu/lodestone_required unless block ~ ~-1 ~ minecraft:lodestone run data modify storage smithed.actionbar:input message set value {priority:'notification',freeze: 50,json:'{"text":"You must be standing on a lodestone","color":"red"}'}

# Wrong dimension
execute if score $WrongDimension clgd.lodestone matches 1 run data modify storage smithed.actionbar:input message set value {priority:'notification',freeze: 50,json:'{"text":"You must be in the same dimension","color":"red"}'}

# Display error message
function #smithed.actionbar:message

# Initialize Warp if success
execute unless predicate clgd.lodestone:warp_failed run function clgd.lodestone:warp

# Return enderpearl if fail
execute if predicate clgd.lodestone:warp_failed run give @s[gamemode=!creative] ender_pearl 1

# Reset fail value
scoreboard players reset $Fail clgd.lodestone
scoreboard players reset $WrongDimension clgd.lodestone